%define	pkg	pfe
%define ver     0.30.89
%define version %{ver}
%define	release	%{_os}
%define	serial	1
%define prefix  /usr/local

Summary:	Portable Forth Environment
Name:		%{pkg}
Version:	%{ver}
Release:	%{release}
Serial:		%{serial}
Copyright:	LGPL
Group:		Development/Languages
URL:		http://sourceforge.net/projects/pfe
Vendor:		Guido Draheim <guidod@gmx.de>
Source0:	http://download.sourceforge.net/%{pkg}/%{pkg}-%{ver}.tar.gz
BuildRoot:	/var/tmp/%{pkg}-%{ver}

Distribution:	Portable Forth Environment
Packager:	Guido Draheim <guidod@gmx.de>

%package doc
Summary:	PFE Documentation
Group:		Development/Libraries

%package share
Summary:	PFE Modules and Scripts
Group:		Development/Libraries
Requires:	pfe

%package devel
Summary:	PFE Development Headers
Group:		Development/Libraries
Requires:       pfe

%description
The Portable Forth Environment is a Forth Engine completly written in C.
It has a module concept so it can be extended with C modules. It is
completly multithreaded, and implements the DPANS94, the proposed ANSI
standard on Forth.

%description doc
The Portable Forth Environment.
The documentation, mostly autogenerated.

%description share
The Portable Forth Environment.
Some extension modules and scripts.

%description devel
The Portable Forth Environment.
The header file for compiling extension modules for
use by the forth engine, or for compiling applications
that use the forth library as a scripting engine.

The headers are namespace clean, i.e. all symbols
have a prefix to distinguish them from other symbols.

%prep
#'
%setup

(mkdir -p Release/rpm-build)
(cd Release/rpm-build && ../../pfe/configure --prefix=%{prefix})

%build
cd $RPM_BUILD_DIR/%{pkg}-%{ver}
%ifarch i586 i686
perl -pi.prerpm -e 's/^(CFLAGS\s*=.*)/\1 -mcpu=%{_target_cpu}/' `find . -name Makefile -o -name Makefile.gc`
%endif
(cd Release/rpm-build && make)
(cd Release/rpm-build && make docs)

%install

if [ -d $RPM_BUILD_ROOT ] && [ ! -L $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
mkdir -p $RPM_BUILD_ROOT%{prefix}
cd $RPM_BUILD_DIR/%{pkg}-%{ver}
(cd Release/rpm-build && make DESTDIR=$RPM_BUILD_ROOT install)
(cd Release/rpm-build && make DESTDIR=$RPM_BUILD_ROOT install-doc)

%clean
if [ -d $RPM_BUILD_ROOT ] && [ ! -L $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi

%files
#    %defattr(-,root,root)
     %{prefix}/bin/%{pkg}
     %{prefix}/lib/lib%{pkg}*
%dir %{prefix}/lib/%{pkg}
%dir %{prefix}/share/%{pkg}

%files doc
#    %config(noreplace) %{prefix}/%{pkg}.conf
%dir %{prefix}/doc/%{pkg}
     %{prefix}/doc/%{pkg}/*

%files share
     %{prefix}/share/%{pkg}/*
     %{prefix}/lib/%{pkg}/*

%files devel
%dir %{prefix}/include/%{pkg}
     %{prefix}/include/%{pkg}/*
     %{prefix}/include/%{pkg}-*


%post doc
echo "PFE Documentation installed"
# %{prefix}/%{pkg}-install && /bin/true
